Open-Source Security Intelligence

Know every vulnerability
before it knows you.

DevGuard continuously monitors your dependencies and alerts you when CVEs like this one affect your stack — with real-time threat intelligence built for developers.

Search

GHSA-r64r-5h43-26qv

HighCVSS 7.5 / 10
Published Jan 24, 2024·Last modified Jan 24, 2024
Affected Components(0)

No affected components available

Description

Summary

Users can report private messages, even when they're neither sender nor recipient of the message. The API response to creating a private message report contains the private message itself, which means any user can just iterate over message ids to (loudly) obtain all private messages of an instance. A user with instance admin privileges can also abuse this if the private message is removed from the response, as they're able to see the resulting reports.

Details

Creating a private message report by POSTing to /api/v3/private_message/report does not validate whether the reporter is the recipient of the message. At least lemmy-ui does not allow the sender to report the message; the API method should likely be restricted to accessible to recipients only. The API response when creating a report contains the private_message_report_view with all the details of the report, including the private message that has been reported:

<details> <summary>Example response</summary>

In the report below, the creator with id 3 is different from the private message creator (id 2) and private message recipient (id 6).

{
  "private_message_report_view": {
    "private_message_report": {
      "id": 14,
      "creator_id": 3,
      "private_message_id": 7,
      "original_pm_text": "testfoo",
      "reason": "reporting id 7",
      "resolved": false,
      "published": "2023-12-15T19:23:03.441967Z"
    },
    "private_message": {
      "id": 7,
      "creator_id": 2,
      "recipient_id": 6,
      "content": "testfoo",
      "deleted": false,
      "read": false,
      "published": "2023-12-15T19:21:41.920872Z",
      "ap_id": "https://1b1w56.lem.rocks/private_message/7",
      "local": true
    },
    "private_message_creator": {
      "id": 2,
      "name": "admin",
      "banned": false,
      "published": "2023-12-14T23:45:05.055427Z",
      "actor_id": "https://1b1w56.lem.rocks/u/admin",
      "local": true,
      "deleted": false,
      "bot_account": false,
      "instance_id": 1
    },
    "creator": {
      "id": 3,
      "name": "testuser1",
      "banned": false,
      "published": "2023-12-14T23:47:57.571772Z",
      "actor_id": "https://1b1w56.lem.rocks/u/testuser1",
      "local": true,
      "deleted": false,
      "bot_account": false,
      "instance_id": 1
    }
  }
}
</details>

If these details were not available in the response, but reports could still be created by any user, or at least by any admin, this would allow an instance admin to create reports and obtain the message contents from the report system.

This was originally discovered from incorrect reports on a 0.18.5 instance and has been replicated in a 0.19.0 test environment.

PoC

curl -v 'https://myinstance.tld/api/v3/private_message/report' -X POST -H 'Content-Type: application/json' -H 'authorization: Bearer ...' --data-raw '{"private_message_id":1,"reason":"i like reports"}'

Impact

Any authenticated user can obtain arbitrary (untargeted) private message contents. Privileges required depend on the instance configuration; when registratons are enabled without application system, the privileges required are practically none. When registration applications are required, privileges required could be considered low, but this assessment heavily varies by instance.

Detection

Any private message reports where the report creator is not equal to the private message recipient may be an attempt to exploit this. As this was originally discovered from an incorrect report, likely related to a bug in a client app, it should be noted that not all mismatching reports should be considered malicious; though a frequent occurrence of them likely indicates an exploitation attempt.

Workaround when updating is not immediately possible

If an update to a fixed Lemmy version is not immediately possible, the API route can be blocked in the reverse proxy. This will prevent anyone from reporting private messages, but it will also prevent exploitation before the update has been applied.

nginx example:

location = /api/v3/private_message/report {
  default_type application/json;
  return 403 '{"error":"couldnt_create_report"}';
}
Risk Scores
Base Score
7.5

The vulnerability can be exploited over the network without needing physical access. It is easy for an attacker to exploit this vulnerability. An attacker does not need any special privileges or access rights. No user interaction is needed for the attacker to exploit this vulnerability. The impact is confined to the system where the vulnerability exists. There is a high impact on the confidentiality of the information.

Threat Intelligence
6.9

Exploitation attempts have been detected. Elevated vigilance and prompt remediation are advised.

EPSS
0.51%

The exploit probability is very low. The vulnerability is unlikely to be exploited in the next 30 days.

Exploit
Not available

We did not find any exploit available. Neither in GitHub repositories nor in the Exploit-Database.

Browse More

Scan your project

Continuously monitor your dependencies and get alerted when vulnerabilities like this one affect your stack.

Checkout DevGuard